function [est_labels, posterior] = eval_logreg(test_X, E, E_bias)
%EVAL_LOGREG Evaluate logistic regressor
%
%   [est_labels, posterior] = eval_logreg(test_X, E, E_bias)
%
%


    % Perform labeling
    log_Pyx = bsxfun(@plus, E' * test_X, E_bias');
    [~, est_labels] = max(log_Pyx, [], 1);
    
    % Compute posterior
    if nargout > 1
        posterior = exp(bsxfun(@minus, log_Pyx, max(log_Pyx, [], 1)));
        posterior = bsxfun(@rdivide, posterior, sum(posterior, 1));
    end