function log_prob = likelihood_mrf(X, G, model)
%LIKELIHOOD_MRF Estimates log-likelihood of stuctured object under MRF
%
%   log_prob = likelihood_mrf(X, G, model)
%
% The function estimates the log-likelihood of the stuctured objects with 
% nodes X and graph G under the specified pairwise MRF.
%
%
% (C) Laurens van der Maaten, 2011
% Delft University of Technology


    % Initialize some variables
    assert(length(X) == length(G));
    no_objects = length(X);
    log_prob = zeros(no_objects, 1);    
        
    % Loop over all time series
    for i=1:no_objects
            
        % Compute log-likelihood of MAP assignment
        [~, ~, log_prob(i)] = sumprod_dai(X{i}, G{i}, model);
    end
    